/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.daemon;

import java.util.Hashtable;
import java.util.Enumeration;
//import java.io.*;

import org.mitre.pam.interfaces.*;

import org.mitre.pam.executive.ExecGlobal;

/**
* When this daemon wakes up it deletes any agents that are flagged as
* depending on a "schedule once" juggler that has "already ran once"
*
* @author Nazario Irizarry, Jr.
*/

/** this code is not complete **/

public class DeleteOnceAgents extends DaemonBase {
	Hashtable expiredAgents = new Hashtable(200,100);
	private static final String DEBUG_KEY = "DeleteOnceAgents";
	public static String DEPENDS_ON = "deleteAfterAgentRunsOnce";
	private static int typesToCheck[] = 
		{ExecToMonitor.DIM, ExecToMonitor.PIM, ExecToMonitor.JUGGLER};
	private static final String LOG_DELETIONS = "logDeletions";
	private static final String DEFAULT_DEPENDENT = "ignore";

	public DeleteOnceAgents() {
		setPeriod(5*60+3);	// every 5 minutes approx
		updateComputer.setLastUpdateTime(System.currentTimeMillis()+2*60*1000);
		setProperty(LOG_DELETIONS,"false");
		metaBooleanInfo(LOG_DELETIONS,false,"Make system log entry when an agent is deleted");
	}
/**
* Upon request we issue callback into exec to get it
* to checkpoint.
*/
	public void doDaemonTask() {
		expiredAgents.clear();
	/*
	* make list of expired agents
	*/
		Enumeration jugglers = ((ExecToMonitor)exec).getListOfActiveModules(ExecToMonitor.JUGGLER);
		while (jugglers.hasMoreElements()) {
			Object next = jugglers.nextElement();
			if (next instanceof Juggler) {
				Juggler nextJuggler = (Juggler) next;
				if (nextJuggler.getStringProperty(ScheduleAttributes.SCHEDULE_VERB,"") == ScheduleAttributes.SCHEDULE_ONCE &&
					nextJuggler.getStringProperty(ScheduleAttributes.NEXT_UPDATE_TIME,"") == ScheduleAttributes.ALREADY_RAN_ONCE 
					) {
					expiredAgents.put(nextJuggler.getId(), nextJuggler);
					reporter.debugMsg(this, "expired -", nextJuggler.getId(), null, DEBUG_KEY);
				}
			}
		}
		if (expiredAgents.size() == 0)
			return;
		boolean logDeletions = getBooleanProperty(LOG_DELETIONS, false);
	/*
	* Look for items that are dependent
	*/
		ExecToEditor exece = (ExecToEditor) exec;
		for (int i = 0; i<typesToCheck.length; i++) {
			Enumeration dependents = exece.getListOfActiveModules(typesToCheck[i]);
			while (dependents.hasMoreElements()) {
				Agent agent = (Agent) dependents.nextElement();
				String dependsOn = agent.getStringProperty(DEPENDS_ON,DEFAULT_DEPENDENT);
				
				if ((dependsOn != DEFAULT_DEPENDENT) && expiredAgents.containsKey(dependsOn)) {
					try {
						exece.deleteNode(agent.getId());
						if (logDeletions)
							reporter.log( "deleted agent\t"+agent.getId());
					}
					catch (org.mitre.pam.store.IntegrityException e) {
						reporter.warning( "can't delete agent\t"+agent.getId());
					}
				}
			}
		}
	}

}