/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.executive;

import org.mitre.pam.interfaces.Task;
import org.mitre.pam.interfaces.ConnectedAgent;

/**
* An interface for an object that understands the message and product flow.
* It is envisioned that there will be various types
* of dispatchers based on whether activations should be immediate, queued,
* synchronous, async, etc
*/
public interface FlowDispatcher {

/**
* Notify, activate a requestors outputs
*/
	public void notifyMyClients(ConnectedAgent requestor, Task taskSet);
/**
* Notify, activate a requestors inputs
*/
	public void executeMySources(ConnectedAgent requestor, Task taskSet);

}