/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.executive;

import java.util.Observable;
import java.util.Enumeration;
import org.mitre.pam.interfaces.Doer;
import org.mitre.pam.interfaces.Tasker;
import org.mitre.pam.interfaces.Task;
import org.mitre.pam.interfaces.Reporter;
import org.mitre.pam.interfaces.Product;
import org.mitre.pam.interfaces.Sink;

/**
* A basic unscheduled command for the exec. 
*
* @author Nazario Irizarry, Jr.
*/
public class GetCommand extends Command {
/**
* Create a GET_PRODUCT command
*/
	public GetCommand (Tasker tasker, Doer doer, Sink sink, Task putToken) {

		super(tasker, doer, GET_PRODUCT);
		this.sinkArg = sink;
		this.putToken = putToken;
		if (reporter.isDebugKey(ExecGlobal.TRACE_MSG_FLOW)) { //avoid unneeded complex string building
			reporter.debugMsg(this,"new (),",toShortString(),null,ExecGlobal.TRACE_MSG_FLOW);
		}
		if (sink == null)
			throw new RuntimeException("null sink");
		if (putToken == null)
			throw new RuntimeException("null putToken");
	}

/**
* the object as a string
*/
	public String toShortString(){
		return "("+command+", from= "+doer+", deliverTo= "+sinkArg+")";

	}
/**
* the object as a string
*/
	public String toString(){
		return "GetCommand"+Integer.toString(idNumber);
	}
}
