/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.executive;




public class VersionInfo {

	private static final int MAJOR_VERSION = 2;
	private static final int MINOR_VERSION = 5;
	private static final int BUILD_NUMBER = 107;


/**
* Get the exec id.  These numbers are guaranteed
* to increase as new versions of the exec come out.  Users
* are encouraged to use whichNumber==0
*
* @param whichNumber 0 - get the build number
* @param whichNumber 1 - get the major version
* @param whichNumber 2 - get the minor version
*/
	static public int getBuildNumber(int whichNumber){
		if (whichNumber == 0)
			return BUILD_NUMBER;
		if (whichNumber == 1)
			return MAJOR_VERSION;
		if (whichNumber == 2)
			return MINOR_VERSION;
		return 0;
	}


}