/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;

import java.awt.event.ComponentListener;
import java.awt.Rectangle;
/**
* Basic interface for an admin/gui tool.
* Allows the org.mitre.pam.monitor.ToolPicker to control
* gui's generically.
*
* @author Nazario Irizarry
*/


public interface AdminTool {

/**
* Tell the tool to become active and to work
*/
	public void setEnabled(boolean enabled);
/**
* Give the tool a handle to the exec
*/
	public void setExec(ExecToController exec);
/**
* Set tools location
*/
	public void setLocation(int x, int y);
/**
* Set visibility
*/
	public void setVisible(boolean visible);
/**
* Add a listener
*/
	public void addComponentListener(ComponentListener listener);
/**
* Set tools title
*/
	public void setTitle(String title);
/**
* Is the tool showing?
*/
	public boolean isVisible();
/**
* Get bounds
*/
	public Rectangle getBounds();
/**
* Set bounds
*/
	public void setBounds(Rectangle bounds);
}