/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;
/**
* Defines a listener interface for exec configuration edits <p>
*
* @author Nazario Irizarry, Jr.
*/

public class ConfigurationEvent extends java.util.EventObject  {
	public int type;
	public static final int NODE_CREATED = 1;
	public static final int NODE_DELETED = 2;
	public static final int CONNECTION_MADE = 3;
	public static final int CONNECTION_BROKEN = 4;
	
	Agent agent;
	ConnectedAgent agentFrom;
	ConnectedAgent agentTo;
	
	/**
	* A node has been created or deleted
	*/
	public ConfigurationEvent(Object source, int type, Agent agent){
		super(source);
		this.agent = agent;
		this.type = type;
	}

	/**
	* A node has been created or deleted
	*/
	public ConfigurationEvent(Object source, int type, ConnectedAgent agentFrom, ConnectedAgent agentTo){
		super(source);
		this.agentFrom = agentFrom;
		this.agentTo = agentTo;
		this.type = type;
	}


	/**
	* A node has been created or destroyed
	*/
	public Agent getAgent(){
		return agent;
	}
			
	/**
	* A connection has been created or destroyed
	*/
	public ConnectedAgent getAgentFrom(){
		return agentFrom;
	}

	/**
	* A connection has been created or destroyed
	*/
	public ConnectedAgent getAgentTo(){
		return agentTo;
	}

}
