/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;

import java.io.File;
import java.util.Hashtable;
import java.util.Enumeration;
import org.mitre.pdif.eventParser.ValueList;

/**
* Defines an active agent. <p>
*
* @author Nazario Irizarry, Jr.
*/
public interface ConnectedAgent extends Agent {
	public static final String HAS_INPUTS = "meta_hasInputs";
	public static final String HAS_OUTPUTS = "meta_hasOutputs";

/**
* Defines a list of outputs 
* that does not include disabled items
*
*/
	public Hashtable getSinkList();	
/**
* A list of inputs 
* that does not include disabled items
*/
	public Hashtable getSourceList();
/**
* The source list returned here is the complete list
* including disabled items
*/
	public Enumeration getFullSourceElementEnumeration();

}
