/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;
import java.util.Enumeration;

import org.mitre.pdif.eventParser.ValueList;



/**
* A memento holds an unordered set of propery-value pairs.
* The memento is used to capture the dynamic state of
* processing modules.<p>
*
* @author Nazario Irizarry, Jr.
*/
public interface Memento extends HasKeyedProperties {

/**
* Attribute name for the unique id for this memento
*/
	public String MEMENTO_UID = "mementoUid";
/**
* Attribute name reserved for future growth
*/
	public String MEMENTO_KIND = "mementoKind";

/**
* Get the memento's unique identifier.  This
* is usually different than the owners id.
*/
	public String getUid();
/**
* @return the number of properties in the memento
*/
	public int size();
/**
* Add a PropertyChangeListener to the listener list.
*/
    public void addMementoListener( MementoListener listener);
/**
* Remove a MementoListener to the listener list.
*
*/
    public void removeMementoListener(MementoListener listener);
/**
* Get parent kind
*/
	public String getParentKind();
/**
* Get parent id
*/
	public String getParentId();
/**
* Set parent info
*/
	public void setParentInfo(String kind, String id);
}
