/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.interfaces;
/**
* Attributes and constants used for scheduling
*
* @author Nazario Irizarry, Jr.
*/
public interface ScheduleAttributes {

	static String[] dayNames = {"Sunday", "Monday", 
						"Tuesday", "Wednesday", "Thursday", 
						"Friday", "Saturday"};
	
	public static String PERIOD = "period";
	public static String NEXT_UPDATE_TIME = "nextUpdateTime";
	public static String NEXT_UPDATE_LONG = "nextUpdateLong";
	public static String LAST_UPDATE_LONG = "lastUpdateLong";
	public static String LAST_UPDATE_TIME = "lastUpdateTime";
	public static String SCHEDULE_VERB = "schedule";

	public static String SCHEDULE_PERIODIC = "periodic";
	public static String SCHEDULE_DAILY = "daily";
/**
* SCHEDULE_MONTHLY not yet to be implemented
*/
	public static String SCHEDULE_MONTHLY = "monthly";
	public static String SCHEDULE_WEEKLY = "weekly";
	public static String SCHEDULE_HOURLY = "hourly";
	public static String SCHEDULE_NONE = "none";
	public static String SCHEDULE_ONCE = "once"; 
	public static String ALREADY_RAN_ONCE = "already ran once"; 
/**
* DEFAULT_DATE_TIME_FORMAT not yet implemented
*/
	public static final String DEFAULT_DATE_TIME_FORMAT = "yyyyMMdd HHmmss"; 

	public static String HOUR_OF_DAY = "hourOfDay";
	public static String DAY_OF_WEEK = "dayOfWeek";
	public static String MINUTE_OF_HOUR = "minuteOfHour";

	public static final long ONE_MINUTE = 1000*60;
	public static final long ONE_HOUR = 1000*60*60;
	public static final long ONE_DAY = 1000*60*60*24;
	
	public static final String[] attributeList = {
		PERIOD,NEXT_UPDATE_TIME, NEXT_UPDATE_LONG, LAST_UPDATE_LONG,
		LAST_UPDATE_TIME, SCHEDULE_VERB, HOUR_OF_DAY, DAY_OF_WEEK, MINUTE_OF_HOUR,
		SCHEDULE_VERB
		};
}
