/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */

package org.mitre.pam.monitor;


/**
 * This class has a static method which instantiates and shows
 * a modal message dialog over the specified window.
 */
import java.awt.Label;
import java.awt.Button;
import java.awt.Frame;
import java.awt.Component;
import java.awt.GridLayout;
public class MessageDlg extends java.awt.Dialog implements java.awt.event.ActionListener, java.awt.event.KeyListener {
	
	private Label messageLabel = new Label();
	private Button OKButton = new Button("OK");


/**
 * creates a modal dialog over the specified frame
 */
private MessageDlg(java.awt.Frame parent) {
	super(parent, "!", true);
	setLayout(new GridLayout(2, 1));
	add(messageLabel);
	OKButton.setSize(66, 30);

	OKButton.addActionListener(this);
	OKButton.addKeyListener(this);
	
	add(OKButton);
}
	public void actionPerformed(java.awt.event.ActionEvent e) {
		setVisible(false);
	}
	
   public void keyPressed(java.awt.event.KeyEvent e) {
   	// do nothing..
   }
   
   public void keyReleased(java.awt.event.KeyEvent e) {
		if (e.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER) {
			setVisible(false);
		}		
   }
   
	public void keyTyped(java.awt.event.KeyEvent e) {
   	// do nothing...
	}	
	
	private void showMessage(String message, int xpos, int ypos) {
		messageLabel.setText(message);
		messageLabel.invalidate();
		pack();
		setResizable(false);
		OKButton.requestFocus();
		setLocation (xpos - getSize().width/2, ypos - getSize().height/2);
		setVisible(true);
	}	
/**
 * this static method shows a message over the specified 
 * component's parent window
 */
	public static void showMessageDlg(Frame targetComp, String msg) {
		MessageDlg msgdlg = new MessageDlg((Frame)targetComp);
/*
		while (!(targetComp instanceof Frame))
			targetComp = (Component)targetComp.getParent();
		if (!(targetComp instanceof Frame)) {
			System.err.println("oops- couldn't find parent frame");
			return;
		}	
		
*/

		int xpos = targetComp.getLocation().x + targetComp.getSize().width / 2;
		int ypos = targetComp.getLocation().y + targetComp.getSize().height / 2;
		msgdlg.showMessage(msg, xpos, ypos); // this blocks
		msgdlg.dispose();
	}

	public void dispose() {
		OKButton.removeActionListener(this);
		OKButton.removeKeyListener(this);
		super.dispose();
	}
}