/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */

package org.mitre.pam.monitor;


/**
 * This class was generated by a SmartGuide.
 * 
 */
import java.awt.Label;
import java.awt.Button;
import java.awt.Panel;
import java.awt.Frame;
import java.awt.Component;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;

public class ThreeButtonDlg extends java.awt.Dialog implements java.awt.event.ActionListener {
	
	private Label messageLabel = new Label();
	private Button buttonOne = new Button("Yes");
	private Button buttonTwo = new Button("No");
	private Button cancelButton = new Button("Cancel");
	private Panel buttonContainer = new Panel(new GridBagLayout());
	private Integer returnVal = null;

/**
 * creates a modal dialog over the specified frame
 */
	private ThreeButtonDlg(java.awt.Frame parent) {
		super(parent, "?", true);
		setLayout(new GridBagLayout());
		GridBagConstraints constraints = new GridBagConstraints();
		constraints.fill = GridBagConstraints.NONE;
		constraints.gridx = 0;
		constraints.gridy = 0;
		constraints.gridwidth = 1;
		constraints.gridheight = 1;
		constraints.ipadx = 0;
		constraints.ipady = 0;
		constraints.anchor = GridBagConstraints.CENTER;
		
		add(messageLabel, constraints);
		
		constraints.insets.right = 5;
		buttonContainer.add(buttonOne, constraints);
		constraints.gridx = 1;
		buttonContainer.add(buttonTwo, constraints);
		constraints.gridx = 2;
		buttonContainer.add(cancelButton, constraints);
		
		constraints.insets.right = 0;
		constraints.gridx = 0;
		constraints.gridy = 1;
		add(buttonContainer, constraints);
	
		buttonOne.addActionListener(this);
		buttonTwo.addActionListener(this);
		cancelButton.addActionListener(this);	
	
	}
	
	public void dispose() {
		buttonOne.removeActionListener(this);	
		buttonTwo.removeActionListener(this);	
		cancelButton.removeActionListener(this);	
		super.dispose();
	}
	
	public void actionPerformed(java.awt.event.ActionEvent e) {
		Object tmp = e.getSource();
		if (tmp == buttonOne)
			returnVal = new Integer(0);
		else if (tmp == buttonTwo)
			returnVal = new Integer(1);
		else
			returnVal = null;
		setVisible(false);
	}	
	private Integer showDialog(String message, String label1, String label2, String cancelLabel, int xpos, int ypos) {
		messageLabel.setText(message);
//		messageLabel.invalidate();
		buttonOne.setLabel(label1);
		if (buttonOne.getPreferredSize().width < 66)
			buttonOne.setSize(66, buttonOne.getSize().height);
		buttonTwo.setLabel(label2);
		if (buttonTwo.getPreferredSize().width < 66)
			buttonTwo.setSize(66, buttonTwo.getSize().height);
		cancelButton.setLabel(cancelLabel);
		if (cancelButton.getPreferredSize().width < 66)
			cancelButton.setSize(66, cancelButton.getSize().height);
		pack();
		setResizable(false);
		buttonOne.requestFocus();
		setLocation (xpos - getSize().width/2, ypos - getSize().height/2);
		setVisible(true);
		return returnVal;
	}	
	public static Integer showThreeButtonDlg(Frame targetComp, String msg) {
		return showThreeButtonDlg(targetComp, msg, "Yes", "No", "Cancel");
	}
	public static Integer showThreeButtonDlg(Frame targetComp, String msg, String label1, String label2) {
		return showThreeButtonDlg(targetComp, msg, label1, label2, "Cancel");
	}	
	public static Integer showThreeButtonDlg(Frame targetComp, String msg, String label1, String label2, String cancelLabel) {
		ThreeButtonDlg tbdlg = null;
/*	
		while (!(targetComp instanceof Frame))
			targetComp = (Component)targetComp.getParent();
		if (!(targetComp instanceof Frame)) {
			System.err.println("ThreeButtonDlg oops- couldn't find parent frame");
			return null;
		}	
*/
		tbdlg = new ThreeButtonDlg((Frame)targetComp);

		int xpos = targetComp.getLocation().x + targetComp.getSize().width / 2;
		int ypos = targetComp.getLocation().y + targetComp.getSize().height / 2;
		Integer answer = tbdlg.showDialog(msg, label1, label2, cancelLabel, xpos, ypos); // this blocks
		
		tbdlg.dispose();
		
		return answer;
	}
}