/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.productVisitor;

import java.util.*;

import org.mitre.pam.interfaces.Product;
import org.mitre.pam.interfaces.ProductVisitor;
import org.mitre.pam.product.view.DictionaryProduct;
import org.mitre.pam.store.FileRef;

/**
* Gets a list of all dictionaries that are referenced by any DictionaryProducts
* contained inside the product we are visiting.
*
* @author John R. Fantry
*
* Note: This is basically the same as AsFlatFileList with small modifications.
*/
public class AsFlatDictList implements ProductVisitor {
	protected Vector list;
/**
*
*/
  public AsFlatDictList () {
	}

	public void visit(Product product) {
		list = new Vector(50);
		process(product, list);
	}
/**
* This enumeration points to products whose content is a FileRef
*/
  public Enumeration getDictList() {
		return list.elements();
	}
/**
* This vector has to products whose content is a FileRef
*/
  public Vector getDictVector() {
		return list;
	}

	private void process(Object product, Vector list) {
		if (product == null)
			return;

		if (product instanceof Product)
			process((Product) product, list);
	}

	private void process(Product product, Vector list) {
		if (product == null)
			return;

    if(product instanceof DictionaryProduct) {
      list.addElement(((DictionaryProduct)product).getDictionary());
      return;
    }

		Object content = product.getContent();
		/*
		* vector contents
		*/
		if (content instanceof Enumeration) {
			Enumeration enum = (Enumeration) content;
			while (enum.hasMoreElements()) {
				process(enum.nextElement(), list);
			}
		}
		/*
		* vector contents
		*/
		else if (content instanceof Vector) {
			Vector cv = (Vector) content;
			for (int i = 0; i< cv.size(); i++) {
				process(cv.elementAt(i), list);
			}
		}
	}
}