/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.productVisitor;

import java.util.*;

import org.mitre.pam.interfaces.Product;
import org.mitre.pam.interfaces.ProductVisitor;
import org.mitre.pam.store.FileRef;

/**
* Gets a list of all products that contain files.
*
* @author Nazario Irizarry, Jr.
*/
public class AsFlatFileList implements ProductVisitor {
	protected Vector list;
/**
* 
*/
	public AsFlatFileList () {
	}
	
	public void visit(Product product) {
		list = new Vector(50);
		process(product, list);
	}
/**
* This enumeration points to products whose content is a FileRef
*/
	public Enumeration getFileProductList() {
		return list.elements();
	}
/**
* This vector has to products whose content is a FileRef
*/
	public Vector getFileProductVector() {
		return list;
	}

	private void process(Object product, Vector list) {
		if (product == null)
			return;

		if (product instanceof Product)
			process((Product) product, list);
	}
	
	private void process(Product product, Vector list) {
//		System.out.println(" AsFlatFileList render");
		if (product == null)
			return;
		Object content = product.getContent();
		/*
		* vector contents
		*/
		if (content instanceof Enumeration) {
			Enumeration enum = (Enumeration) content;
//			System.out.println(" AsFlatFileList, vector content, size "+cv.size());
			while (enum.hasMoreElements()) {
				process(enum.nextElement(), list);
			}
		}
		/*
		* vector contents
		*/
		else if (content instanceof Vector) {
			Vector cv = (Vector) content;
//			System.out.println(" AsFlatFileList, vector content, size "+cv.size());
			for (int i = 0; i< cv.size(); i++) {
				process(cv.elementAt(i), list);
			}
		}
		/*
		* FileRef contents
		*/
		else if (content instanceof FileRef) {
//			System.out.println(" AsFlatFileList, file");
			list.addElement(product);
		}
	}
}
