/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
/*--------------------------------------------------------------------------
  Copyright (c) 1998 by The MITRE Corporation.  All rights reserved.
--------------------------------------------------------------------------*/
package org.mitre.pam.rmi.editor;

import java.rmi.Remote;
import java.rmi.RemoteException;

import java.util.Enumeration;

/**
* Basic framework methods implemented by the executive and made
* available via RMI. These methods provide access to executive-level
* information.
* <P>
* @see        org.mitre.pam.interfaces.ExecCallbacks
*
 * @author Michael E. Los, MITRE, D510
 * @author Nazario Irizarry, Jr., MITRE
*/
public interface RemoteExecCallbacks extends java.rmi.Remote
{
  /**
  * Returns the build number of the running executive.
  * These numbers are guaranteed
  * to increase as new versions of the exec come out.  Users
  * are encouraged to use whichNumber==0
  *
  * @param whichNumber 0 - get the build number
  * @param whichNumber 1 - get the major version
  * @param whichNumber 2 - get the minor version
  *
  * @return       integer denoting the build number
  * @exception    java.rmi.RemoteException
  */
  public int getBuildNumber(int whichNumber)
                      throws RemoteException;
}