/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;

import org.mitre.pam.executive.Module;


/**
* A hashtable that answers requests for enumeration with an enumeration
* of only enabled items. <p>
*
* @author Nazario Irizarry, Jr.
*/
public class EnabledTable extends Hashtable {

	public Enumeration keys() {
		Vector list = new Vector(size());
		
		Enumeration keyList = super.keys();
		while (keyList.hasMoreElements()) {
			Object key = keyList.nextElement();
			
			Module item = (Module) get(key);
			if (item.isEnabled())
				list.addElement(key);
		}
		
		return list.elements();
		
	}

	public Enumeration elements() {
		Vector list = new Vector(size());
		
		Enumeration elementList = super.elements();
		while (elementList.hasMoreElements()) {
			Module item = (Module) elementList.nextElement();
			if (item.isEnabled())
				list.addElement(item);
		}
		
		return list.elements();
		
	}
	
	public Enumeration allElements() {
		return super.elements();
	}
	
	public int size() {
		int count = 0;
		
		Enumeration elementList = super.elements();
		while (elementList.hasMoreElements()) {
			if (((Module) elementList.nextElement()).isEnabled())
				count++;
		}
		return count;
	}
	
	public int unfilteredSize() {
		return super.size();
	}
	
	public boolean contains(Object obj) {
		return super.contains(obj);
	}
}