/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

import java.util.Enumeration;


/**

* Allows you to build a composite enumeration that is a sequential

* "join" of two enumerations.

*/

public class JoinEnumeration implements Enumeration {
	Enumeration e1;
	Enumeration e2;
	boolean firstSet;
	
	public JoinEnumeration(Enumeration e1, Enumeration e2) {
		this.e1 = e1;
		this.e2 = e2;
		firstSet = true;
	}
	
	public boolean hasMoreElements() {
		if (firstSet && e1.hasMoreElements()) 
			return true;
		else {
			firstSet = false;
			return e2.hasMoreElements();
			}
	}
	
	public Object nextElement() {
		if (firstSet && e1.hasMoreElements()) 
			return e1.nextElement();
		else {
			firstSet = false;
			return e2.nextElement();
			}
	}
}
