/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

import java.io.PrintWriter;
import java.io.OutputStream;
/**
 * A subclass of java.io.PrintWriter that handles crlf pairs for web output.
 *
 * @version 	1, 15 Jul 1997
 * @author	Nazario Irizarry
 */
public class PrintCRLFStream extends PrintWriter {
    private boolean autoflush;
    private boolean trouble;

    /**
     * Creates a new PrintCRLFStream.
     * @param out	the output stream
     */
    public PrintCRLFStream(OutputStream out) {
    	super(out);
    }

    /**
     * Creates a new PrintWriter, with auto flushing.
     * @param out	the output stream
     * @param autoflush if true the stream automatically flushes
     *		its output when a newline character is printed
     */
    public PrintCRLFStream(OutputStream out, boolean autoflush) {
    	super(out, autoflush);
    }

    /**
     * Writes a byte. This method will block until the byte is actually
     * written.
     * @param b the byte
     * @exception IOException If an I/O error has occurred.
     */
    public void write(int b) {
    	if (b == '\n')
    		super.write('\r');
    	super.write(b);
    }
    
}
