/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

import java.io.Serializable;

/**
* Used by the SortedHash class
* @author Nazario Irizarry
*/

public class SortedLink implements Serializable {

	Object key;
	Object value;

	SortedLink(Object key, Object value) {
		if (key instanceof AttributeKey)
			throw new RuntimeException("SortedLink key cannot be of type AttributeKey");
		this.key = key;
		this.value = value;
	}
	
	public String toString() {
		return "SortedLink   k="+key+",   v="+value;
	}
	
	public Object getKey() {
		return key;
	}
	
	public Object getValue() {
		return value;
	}
}