/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util;

import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Vector;
import java.awt.Rectangle;

import org.mitre.pdif.eventParser.ValueList;
import org.mitre.pam.interfaces.AdminTool;
import org.mitre.pam.interfaces.Memento;

/**
* A collection of methods.
*
* @author Nazario Irizarry, Jr.
*/
final public class WindowUtil extends Hashtable {
/**
* Looks up the bounds information for the specified window in the specified memento
*
* @return null if there is no bounds information in the Memento
*/
	final public static Rectangle restoreWindowBoundsFromMemento(String windowName, Memento options) {
		ValueList list = options.getPropertyValues(windowName);
		if (list != null && list.size() == 4) {
			Rectangle bounds = new Rectangle(20,20,100,100);
			bounds.x = Integer.parseInt(list.elementAt(0));
			bounds.y = Integer.parseInt(list.elementAt(1));
			bounds.width = Integer.parseInt(list.elementAt(2));
			bounds.height = Integer.parseInt(list.elementAt(3));
			return bounds;
		}
		return null;
	}



/**
* Store up the bounds information for the specified window in the specified memento
*
*/
	final public static void storeWindowBoundsToMemento(String windowName, Rectangle bounds, Memento options) {
		String[] list = new String[4];

		list[0] = Integer.toString(bounds.x);
		list[1] = Integer.toString(bounds.y);
		list[2] = Integer.toString(bounds.width);
		list[3] = Integer.toString(bounds.height);
		options.setPropertyValues(windowName, new ValueList(list));
	}
}