/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
/**
* An alarm event has a category, a level and a message
* @author Tim Taylor
*/
package org.mitre.pam.util.alarm;

class AlarmEvent {
  private String category;
  private String    level;
  private String msg;
  private Throwable exception;

  public AlarmEvent(String category, String level, String msg) {
    this.category = category;
    this.level    = level;
    this.msg      = msg;
  }

  public AlarmEvent(String category, String level, Throwable exception) {
    this.category = category;
    this.level    = level;
    this.exception      = exception;
  }

  public String getCategory() {
    return category;
  }

  public String getLevel() {
    return level;
  }

  public String getMessage() {
  	if (msg != null)
    	return msg;
    if (exception != null)
    	return exception.toString()+"\n";
    return "<invalid alarm event>";
  }
  public Throwable getThrowable() {
    return exception;
  }
}