/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.util.draw;

import java.awt.*;
import java.util.Vector;

import org.mitre.pam.interfaces.Agent;

public class GhostBlock extends Block {
	Graphics graphics;
	
	GhostBlock(DrawParent parent, Rectangle rect) {
		setParent(parent);
		boundingRect.x = rect.x;
		boundingRect.y = rect.y;
		boundingRect.width = rect.width;
		boundingRect.height = rect.height;
		name = "ghostBlock*!*!";
	}

	GhostBlock(DrawParent parent, Block blockToShadow) {
		setParent(parent);
		boundingRect.x = blockToShadow.boundingRect.x;
		boundingRect.y = blockToShadow.boundingRect.y;
		boundingRect.width = blockToShadow.boundingRect.width;
		boundingRect.height = blockToShadow.boundingRect.height;
		deltaXtoMark = blockToShadow.deltaXtoMark;
		deltaYtoMark = blockToShadow.deltaYtoMark;
		moveToX = blockToShadow.moveToX;
		moveToY = blockToShadow.moveToY;
		name = "ghostBlock*!*!";
	}

	
	void setShowAsEnabled(boolean drawAsEnabled) {
	}
	
	void select() {
	}

	void unselect() {
	}
	
	public synchronized void moveTo(int x, int y) {
	/*
	* Refresh the old position and connecting lines
	*/
		parent.needsRefresh(boundingRect);
		boundingRect.x = x - boundingRect.width/2;
		boundingRect.y = y - boundingRect.height/2;
		parent.needsRefresh(boundingRect);
	}
	
	
	public synchronized void paint(Graphics g) {
	/*
	* draw outline
	*/
		g.setColor(Color.lightGray);
		g.drawRect(boundingRect.x, boundingRect.y, boundingRect.width-1, boundingRect.height-1);
	}
	

	boolean isRubberbandLoc(int x, int y) {
		return false;
	}
	
	
}