/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pdif.eventParser;

import java.io.PrintWriter;
import java.io.IOException;
import java.util.Hashtable;
import java.util.Enumeration;
import java.util.Date;
/**
* An experimental storage manager used in conjunction with PDIFItem
* @see PDIFItem
* @author Nazario Irizarry, Jr.
*/

public class PDIFOutManager {
	Hashtable partsAlreadyOutput = new Hashtable(20);
	Hashtable partsHaveRelation = new Hashtable(20);
	Hashtable partsNeedOutput;

	
	public PDIFOutManager() {
		partsNeedOutput = new Hashtable(20);
	}

	public PDIFOutManager( Hashtable partsNeedOutput) {
		this.partsNeedOutput = (Hashtable) partsNeedOutput.clone();
	}

	

	public void addPartAlreadyOutput(Object id, Object part) {
		partsAlreadyOutput.put(id, part);
		partsNeedOutput.remove(id);
	}

	public void addPartHasRelation(PDIFItem part) {
		partsHaveRelation.put(part.getUid(), part);
	}

	
	public void addNeedsOutput(PDIFItem product) {
		String partId = product.getUid();
		
		if (partsAlreadyOutput.containsKey(partId))
			return;
		if (partsNeedOutput.containsKey(partId))
			return;
		partsNeedOutput.put(partId, product);
	}
	
	public Enumeration getNeedsOutputEnumeration() {
		return partsNeedOutput.elements();
	}

	public Enumeration getRelationEnumeration() {
		return partsHaveRelation.elements();
	}
	
	public boolean hasNeedOutputParts() {
		return partsNeedOutput.size() > 0;
	}

	public boolean hasRelations() {
		return partsHaveRelation.size() > 0;
	}
}