import org.mitre.pam.executive.ExecGlobal;
import org.mitre.pam.executive.Exec;
import org.mitre.pam.interfaces.ExecToController;
import org.mitre.pam.interfaces.IPamPlugin;
/**
* An iPAM plugin, that integrates Jess
*
* @author Nazario Irizarry, Jr.
*/
public class PAMSmart implements IPamPlugin {
/**
* Define agents unique to pamSmart
*/
	public static void defineModules(ExecToController exec) {				
		exec.defineModuleAlias("infer", "org.mitre.pam.daemon.rules.Infer");
		exec.defineModuleAlias("delayedSetProperty", "org.mitre.pam.daemon.DelayedSetProperty");
		exec.defineModuleAlias("propertyTimer", "org.mitre.pam.daemon.PropertyTimer");
	}
/**
* Checks all the known support directories to ensure that
* they exist and have some minimum number of files
*/
	static public boolean isOkToLoad(ExecToController exec, String[] cmdLineArgs) {
		try {
			Class exists = Class.forName("jess.Jesp");
		}
		catch (ClassNotFoundException ignore) {
			exec.getExecAsAgent().getReporter().warning("Can't find JESS classes in the classpath");
			return false;
		}
		return true;
	}
/**
* This is modeled after java.lang.Package call by same name
*/
	public static String getImplementationVersion() {
		return "1.0.2";
	}
}

