package org.mitre.pam.daemon.rules;

import java.util.Hashtable;
import org.mitre.pam.interfaces.Agent;
import jess.Fact;

/**
*  An extension of Hashtable to keep track of a memento's parent
* and the agents rootFact.  The rootFact is a Jess unordered
* fact with a defTemplate that all PAM agents share.
*
* @author Nazario Irizarry
* @author Jason Mathews. 3/9/99 Added orderedFactName to create custom assertions.
*/

class PropertiesTable extends Hashtable {
	Agent agent;
	Fact rootFact;
	boolean specialAttributes;
	String orderedFactName;

	public PropertiesTable(int size, Agent agent) {
		super(size);
		setAgent(agent);
	}
	
	public void setAgent(Agent agent) {
		this.agent = agent;
	}
	public Agent getAgent() {
		return agent;
	}
	
	public void setOrderedFactName(String factName) {
		orderedFactName = factName;
	}

	public String getOrderedFactName() {
		return orderedFactName;
	}
	
	public void setRootFact(Fact f) {
		this.rootFact = f;
	}
	public Fact getRootFact() {
		return rootFact;
	}
	public boolean hasSpecialAttributes() {
		return specialAttributes;
	}
	public void setSpecialAttributes(boolean flag) {
		this.specialAttributes = specialAttributes;
	}
}
      
/*            
            ValueList values = mem.getPropertyValues(name);
            Value newV;
            if (values.size() > 1) { // multislot
            	ValueVector vv = new ValueVector(values.size());
            	Enumeration evals = values.elements();
            	while (evals.hasMoreElements()) {
            		vv.add(new Value(((String)evals.nextElement()), RU.STRING));
            	}
            	newV = new Value(vv, RU.LIST);
            }
            else {	//single slot
            	newV = new Value(mem.getProperty(name), RU.STRING);
            }
*/
