/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.daemon.rules;

import jess.Rete;
import jess.Userpackage;

import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.Reporter;
import org.mitre.pam.interfaces.ExecToEditor;

/**
*  Reflect PAM agents into Jess
*
* @author Nazario Irizarry, Jr using Jess sources for examples
*/
class ReflectAgent implements Userpackage 
{
	AssertAgent aa;
	ExecToEditor exec;
	Reporter reporter;
	
	ReflectAgent(ExecToEditor exec, Reporter reporter, SyncSemaphore triggerObject) {
		aa = new AssertAgent(exec, reporter, triggerObject);
		this.exec = exec;
		this.reporter = reporter;
	}
	
	public void add(Rete engine) {
		aa.setEngine(engine);
		engine.addUserfunction(aa);
		engine.addClearable(aa);
		engine.addResetable(aa);
		
		AssertKind ak = new AssertKind(aa);
		engine.addUserfunction(ak);
		engine.addResetable(ak);

		// Generic jess user functions
		engine.addUserfunction(new RetractAgent(aa));
		engine.addUserfunction(new AssertAllAgents(aa));
		engine.addUserfunction(new AssertAgentAndConnections(aa, reporter, exec));
		engine.addUserfunction(new AssertReport(exec, aa));
		engine.addUserfunction(new AssertAgentAttributes(aa, reporter, exec));
		engine.addUserfunction(new DumpFacts(engine));
		engine.addUserfunction(new EditAgent());
		engine.addUserfunction(new SendEMail());
		engine.addUserfunction(new CopyFile(reporter));
		engine.addUserfunction(new AgentExists(reporter, exec));
		engine.addUserfunction(new AddTimer(reporter, exec));
		engine.addUserfunction(new WriteToLog(reporter, exec));

		engine.addUserfunction(new FactStartsWith(engine));
		engine.addUserfunction(new FindFact(engine));
		engine.addUserfunction(new BuildUniqueAgent(reporter, exec));
	}

}

