package org.mitre.pam.daemon.rules;

import org.mitre.pam.daemon.rules.AssertAgent;
import org.mitre.pam.executive.ExecGlobal;
import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.ExecToEditor;
import jess.Context;
import jess.RU;
import jess.ReteException;
import jess.Userfunction;
import jess.Value;
import jess.ValueVector;

/**
* Retract an entire PAM agent's facts
*/

class RetractAgent implements Userfunction
{
	private String funcName = "retractAgent";
	ExecToEditor exec;
	AssertAgent assertAgent;

	RetractAgent(AssertAgent assertAgent) {
		this.assertAgent = assertAgent;
		exec = ExecGlobal.getExec();
	}

	public String name() { 
		return funcName;
	}

	public Value call(ValueVector vv, Context context) throws ReteException
	{
	    String agentId = vv.get(1).stringValue();
	    
	    if (agentId == null)
	    	throw new ReteException("retractAgent","arg 1 must not be null","");

        Agent agent = exec.getActiveAgent(agentId);
	    if (agent == null)
	    	throw new ReteException("retractAgent","no such agent",agentId);

		return assertAgent.retractAgent(agent);
	}
  
}
