package org.mitre.pam.daemon.rules;

import java.io.IOException;

import org.mitre.pam.util.smtp.MIMEc;
import org.mitre.pam.util.smtp.SendMail;

import jess.Context;
import jess.Funcall;
import jess.ReteException;
import jess.RU;
import jess.Userfunction;
import jess.Value;
import jess.ValueVector;


class SendEMail implements Userfunction {

  private String m_name = "sendMail";


  public SendEMail() {
  }

  public String name() {
		return m_name;
  }

  public Value call(ValueVector vv, Context context) throws ReteException {
    if(vv.size() < 6) {
      return Funcall.FALSE();
    }

    String body = vv.get(1).stringValue();
    String subject = vv.get(2).stringValue();
    String to = vv.get(3).stringValue();
    String from = vv.get(4).stringValue();
    String SMTPserver = vv.get(5).stringValue();

    MIMEc message = new MIMEc();
    message.setTo(to);
    message.setFrom(from);
    message.setSubject(subject);
    message.setBody(body);

    return sendMail(SMTPserver, message);
  }

  protected Value sendMail(String SMTPserver, MIMEc message) {

    SendMail mailer = new SendMail(SMTPserver);

    try {
      mailer.sendMail(message);
    } catch(IOException ioe) {
      return Funcall.FALSE();
    }

    return Funcall.TRUE();
  }
}