/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.aggregator.detectChange;

import java.util.Hashtable;
/**
* SignatureTable is a hashtable designed to "fool" a casual
* hashtable user.  A "normal" user would think that this
* is a table of Longs.  Thus, when this is merged with
* the channel's memento, the state of the CRC table gets saved.
*
* @author Nazario Irizarry, Jr.
*/
class SignatureTable extends Hashtable {
	
	public SignatureEntry getCRCEntry(Object key) {
		return (SignatureEntry) super.get(key);
	}

	public Object get(Object key) {
		SignatureEntry entry = (SignatureEntry) super.get(key);
		if (entry != null)
			return Long.toString(entry.crc);
		else {
			return null;
		}
	}
/*	public String getProperty(String key) {
		SignatureEntry entry = (SignatureEntry) super.get(key);
		if (entry != null)
			return Long.toString(entry.crc);
		else {
			return null;
		}
	}
*/
}

