/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.getter.search.altavista;

import java.util.Date;
import java.util.Vector;
import java.util.Enumeration;
import java.util.Hashtable;
import java.io.*;
import java.net.*;

import org.mitre.pam.getter.search.parse.LoggingHTMLParser;
import org.mitre.pam.getter.search.parse.ParseException;
import org.mitre.pam.interfaces.Reporter;
import org.mitre.pam.getter.search.ThreePart;

/**
* Parse results from altavista.
*
* @author Nazario Irizarry, Jr. version 2
* @author Jason Mathews 7/27/99 [iPAM 2.3.72]
* 	- AltaVista98 used same URL syntax as AltaVista97 so makeUrlString doesn't need to be changed
* 	  only scan method needs to be overridden.
*/

public class GetOnePage98 extends GetOnePage97 {

/*
	public static void main(String args[]) {
		main();
	}

	public static void main() {
		Vector words = new Vector();
		Vector xwords = new Vector();
		words.addElement("mariner");
		words.addElement("mariner");
		xwords.addElement("sex");
		xwords.addElement("nude");
		
		ExecCallbacks exec = org.mitre.pam.executive.ExecGlobal.getExec();
		System.out.println("findings...");
		GetOnePage getter = new GetOnePage(exec,"test");
		try {
			File f = new File("testdata:altavista answer");

			getter.getNow(words, xwords, f);
			Vector list = getter.getResults();
			for (int i=0; i<list.size(); i++) {
			     ThreePart it = (ThreePart) list.elementAt(i);
			     System.out.println(" 0 "+it.id);
			     System.out.println(" 1 "+it.description);
			     System.out.println(" 2 "+it.url);
			     System.out.println();

			}
		}
		catch (Exception e) {
			e.printStackTrace();			
			System.out.println("items in result "+getter.getResults().size());
		}
		System.out.println(" ... end of findings ...");

		
	}
	private GetOnePage98(ExecCallbacks exec, String id) {
		this.exec = exec;
		this.id = id;
	}
*/

	public GetOnePage98(Reporter reporter, String id, String urlPart0, String urlPart1) {
		super(reporter, id, urlPart0, urlPart1);
	}

	protected void scan(LoggingHTMLParser parser) throws ParseException {
	      for (int i = 1; i< 10; i++) {
			ThreePart s = new ThreePart();
		      	parser.SkipToAfterString(i+".");
//System.out.println(i+".");
			parser.SkipToOpenTag(LoggingHTMLParser.A);
			Hashtable params = parser.ProcessParameters();
			s.url = (String)params.get("HREF");         // get link
//System.out.println("s.url = "+s.url);
			if (s.url == null)
				return;
		
			parser.SkipToEndOfTag();
			s.id = parser.GetUntilTag("</a>");          // get title
//System.out.println("s.id = "+s.id);
			if (s.id == null)
				return;
			s.id = LoggingHTMLParser.removeString(s.id, "<strong>");
			s.id = LoggingHTMLParser.removeString(s.id, "</strong>");
			s.id = LoggingHTMLParser.removeString(s.id, "</b>");
			s.id = LoggingHTMLParser.removeString(s.id, "<b>");
		
			parser.SkipToAfterCloseTag(LoggingHTMLParser.FONT);
			s.description = parser.GetUntilOpenTagOfType(LoggingHTMLParser.FONT);
//System.out.println("s.description = "+s.description);
			if (s.description == null)
				return;
			s.description = LoggingHTMLParser.removeAllStrings(s.description, "&nbsp;");
			s.description = LoggingHTMLParser.stripHTML(s.description);
		
			results.addElement(s);
		}
	}
}
