/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.getter.search.parse;
import java.io.FilterInputStream;
import java.io.IOException;
import java.io.InputStream;

/**
* An input stream that clears each MSB on each byte.
*
* @author Nazario Irizarry, Jr.
*/

public class SevenBitFilter extends FilterInputStream{

    public SevenBitFilter(InputStream in) {
		super(in);
    }

    public int read() throws IOException {
		return 0x7F & in.read();
    }

    public int read(byte b[]) throws IOException {
		int len = read(b, 0, b.length);
		for (int i=0; i<len; i++) 
			b[i] &= 0x7F;
		return len;
    }

    public int read(byte b[], int off, int len) throws IOException {
		int n = in.read(b, off, len);
		for (int i=0; i<n; i++) 
			b[i+off] &= 0x7F;
		return n;
    }

}