/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.getter.search.smarTraveler;

import java.util.Vector;
import java.util.StringTokenizer;

import org.mitre.pam.getter.search.parse.ParseException;
import org.mitre.pam.interfaces.Reporter;

public abstract class GetTraveler {

  protected Reporter reporter;
  protected String travelerURLString;
  protected Vector stories = new Vector(2);
  protected String title = "";
  protected boolean useShortSectionLabels = false;

  public GetTraveler(Reporter reporter, String urlString) {
	this.reporter = reporter;
    if (urlString == null)
      travelerURLString = "";
    else {
    if (urlString.startsWith("file:")) {
	int ind = urlString.indexOf('?');
	// truncate any parameters off of file URLs
	if (ind > 0) urlString = urlString.substring(0,ind);
	}
      travelerURLString = urlString;
    }
  }

  public abstract void getNow() throws java.io.IOException, ParseException;

  public Vector getStories() {
	return stories;
  }

  public String getTitle() {
	return title;
  }

  public void setShortLabels(boolean useShortSectionLabels) {
	this.useShortSectionLabels = useShortSectionLabels;
  }

  protected static String abbreviateRoute(String sectionTitle) {
	StringBuffer buf = new StringBuffer();
	StringTokenizer st = new StringTokenizer(sectionTitle, " ");
	while (st.hasMoreElements()) {
		String s = (String) st.nextElement();
		if (s.equals("North")) buf.append('N');
		else if (s.equals("South")) buf.append('S');
		else if (s.equals("East")) buf.append('E');
		else if (s.equals("West")) buf.append('W');
		else if (s.equals("and")) buf.append(',');
		else {
			if (s.equals("between")) s = "btwn";
			if (buf.length() != 0) buf.append(' ');
			buf.append(s);
		}
	} //while

	return buf.toString();
  }
}
