/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor;

import java.awt.*;
import java.util.Enumeration;
import java.util.Vector;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.io.IOException;

import org.mitre.pam.interfaces.ExecToController;
import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.Reporter;
import org.mitre.pam.store.IntegrityException;
import org.mitre.pdif.eventParser.ValueList;
import org.mitre.pam.interfaces.AdminTool;

/**
* @author Nazario Irizarry
*/
public final class SimpleAdminFrame extends Frame implements AdminTool
{
	Vector currentAgentProperties;
	Agent currentAgent;
	ExecToController exec;
	Reporter reporter;

	public SimpleAdminFrame()
	{
		// This code is automatically generated by Visual Cafe when you add
		// components to the visual environment. It instantiates and initializes
		// the components. To modify the code, only use code syntax that matches
		// what Visual Cafe can generate, or Visual Cafe may be unable to back
		// parse your Java file into its visual environment.
		//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		setVisible(false);
		setSize(400,100);
		SimpleAdminPanel = new java.awt.Panel();
		GridBagLayout gridBagLayout;
		gridBagLayout = new GridBagLayout();
		SimpleAdminPanel.setLayout(gridBagLayout);
		SimpleAdminPanel.setBounds(0,0,400,100);
		SimpleAdminPanel.setFont(new Font("Dialog", Font.PLAIN, 10));
		add("Center", SimpleAdminPanel);
		label1Agent = new java.awt.Label("Agent");
		label1Agent.setBounds(39,5,48,22);
		GridBagConstraints gbc;
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 0;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(5,0,2,0);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(label1Agent, gbc);
		SimpleAdminPanel.add(label1Agent);
		labelProperty = new java.awt.Label("Property");
		labelProperty.setBounds(161,5,65,22);
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 0;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(5,0,2,0);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(labelProperty, gbc);
		SimpleAdminPanel.add(labelProperty);
		labelValue = new java.awt.Label("Value");
		labelValue.setBounds(307,5,46,22);
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 0;
		gbc.weightx = 1.0;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(5,0,2,0);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(labelValue, gbc);
		SimpleAdminPanel.add(labelValue);
		choiceForAgent = new java.awt.Choice();
		choiceForAgent.addItem("<none>");
		choiceForAgent.setBounds(3,32,121,16);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 1;
		gbc.weightx = 2.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,3,0,3);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(choiceForAgent, gbc);
		SimpleAdminPanel.add(choiceForAgent);
		choiceForProperty = new java.awt.Choice();
		choiceForProperty.addItem("<none>");
		choiceForProperty.setBounds(130,32,128,16);
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 1;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,3,0,3);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(choiceForProperty, gbc);
		SimpleAdminPanel.add(choiceForProperty);
		textFieldForValue = new java.awt.TextField();
		textFieldForValue.setBounds(264,33,132,14);
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 1;
		gbc.weightx = 3.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,3,0,3);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(textFieldForValue, gbc);
		SimpleAdminPanel.add(textFieldForValue);
		buttonDeleteAgent = new java.awt.Button();
		buttonDeleteAgent.setLabel("Delete Agent");
		buttonDeleteAgent.setBounds(10,55,107,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 2;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,0,10);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(buttonDeleteAgent, gbc);
		SimpleAdminPanel.add(buttonDeleteAgent);
		buttonDeleteAgent.setEnabled(false);
		buttonDeleteProperty = new java.awt.Button();
		buttonDeleteProperty.setLabel("Delete Property");
		buttonDeleteProperty.setBounds(137,55,114,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 1;
		gbc.gridy = 2;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,0,10);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(buttonDeleteProperty, gbc);
		SimpleAdminPanel.add(buttonDeleteProperty);
		buttonDeleteProperty.setEnabled(false);
		buttonChangeProperty = new java.awt.Button();
		buttonChangeProperty.setLabel("Change Property");
		buttonChangeProperty.setBounds(276,55,108,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 2;
		gbc.gridy = 2;
		gbc.fill = GridBagConstraints.NONE;
		gbc.insets = new Insets(0,0,0,0);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(buttonChangeProperty, gbc);
		SimpleAdminPanel.add(buttonChangeProperty);
		buttonChangeProperty.setEnabled(false);
		buttonRefresh = new java.awt.Button();
		buttonRefresh.setLabel("Refresh");
		buttonRefresh.setBounds(10,79,107,17);
		gbc = new GridBagConstraints();
		gbc.gridx = 0;
		gbc.gridy = 3;
		gbc.weightx = 1.0;
		gbc.weighty = 1.0;
		gbc.fill = GridBagConstraints.HORIZONTAL;
		gbc.insets = new Insets(0,10,0,10);
		((GridBagLayout)SimpleAdminPanel.getLayout()).setConstraints(buttonRefresh, gbc);
		SimpleAdminPanel.add(buttonRefresh);
		setTitle("Admin Changes");
		//}}

		//{{INIT_MENUS
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymItem lSymItem = new SymItem();
		choiceForAgent.addItemListener(lSymItem);
		choiceForProperty.addItemListener(lSymItem);
		SymAction lSymAction = new SymAction();
		buttonDeleteAgent.addActionListener(lSymAction);
		buttonDeleteProperty.addActionListener(lSymAction);
		buttonChangeProperty.addActionListener(lSymAction);
		SymText lSymText = new SymText();
		textFieldForValue.addTextListener(lSymText);
		buttonRefresh.addActionListener(lSymAction);
		//}}

		setListsToUnknown();
	}

	public SimpleAdminFrame(String title)
	{
		this();
		setTitle("Property Change, "+title);
	}

    /**
     * Shows or hides the component depending on the boolean flag b.
     * @param b  if true, show the component; otherwise, hide the component.
     * @see java.awt.Component#isVisible
     */
    public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
		super.setVisible(b);
	}

	public void addNotify()
	{
	    // Record the size of the window prior to calling parents addNotify.
	    Dimension d = getSize();
	    
		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		setSize(insets().left + insets().right + d.width, insets().top + insets().bottom + d.height);
		Component components[] = getComponents();
		for (int i = 0; i < components.length; i++)
		{
			Point p = components[i].getLocation();
			p.translate(insets().left, insets().top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

    // Used for addNotify check.
	boolean fComponentsAdjusted = false;

	//{{DECLARE_CONTROLS
	java.awt.Panel SimpleAdminPanel;
	java.awt.Label label1Agent;
	java.awt.Label labelProperty;
	java.awt.Label labelValue;
	java.awt.Choice choiceForAgent;
	java.awt.Choice choiceForProperty;
	java.awt.TextField textFieldForValue;
	java.awt.Button buttonDeleteAgent;
	java.awt.Button buttonDeleteProperty;
	java.awt.Button buttonChangeProperty;
	java.awt.Button buttonRefresh;
	//}}

	//{{DECLARE_MENUS
	//}}

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
			Object object = event.getSource();
			if (object == SimpleAdminFrame.this)
				SimpleAdminFrame_WindowClosing(event);
		}
	}
	
	void SimpleAdminFrame_WindowClosing(java.awt.event.WindowEvent event)
	{
		setVisible(false);		 // hide the Frame
	}

	class SymItem implements java.awt.event.ItemListener
	{
		public void itemStateChanged(java.awt.event.ItemEvent event)
		{
			Object object = event.getSource();
			if (object == choiceForAgent)
				choiceForAgent_ItemStateChanged(event);
			else if (object == choiceForProperty)
				choiceForProperty_ItemStateChanged(event);
		}
	}

	void choiceForAgent_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		String selection = choiceForAgent.getSelectedItem();
		if (selection == NONE) {
			setListsToUnknown();
		}
		else {
			displayAgent(selection);
			updateButtonEnables();
		}
		
	}

	void choiceForProperty_ItemStateChanged(java.awt.event.ItemEvent event)
	{
		String selection = choiceForProperty.getSelectedItem();
		if (selection == NONE || selection == null) {
			setPropertyToUnknown();
		}
		else {
			textFieldForValue.setText(currentAgent.getProperty(selection));
			updateButtonEnables();
		}
	}

	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == buttonDeleteAgent)
				buttonDeleteAgent_ActionPerformed(event);
			else if (object == buttonDeleteProperty)
				buttonDeleteProperty_ActionPerformed(event);
			else if (object == buttonChangeProperty)
				buttonChangeProperty_ActionPerformed(event);
			else if (object == buttonRefresh)
				buttonRefresh_ActionPerformed(event);
		}
	}

	void buttonDeleteAgent_ActionPerformed(java.awt.event.ActionEvent event)
	{
		String nodeId = choiceForAgent.getSelectedItem();
		if (nodeId == null || nodeId == NONE)
			return;
			
		try {
			exec.deleteNode(nodeId);
		} 
		catch (IntegrityException e) {
			reporter.log("Can't delete"+nodeId);
		}
		
		refreshAgentList();
	}

	void buttonDeleteProperty_ActionPerformed(java.awt.event.ActionEvent event)
	{
		String nodeId = choiceForAgent.getSelectedItem();
		Agent agent = exec.getActiveAgent(nodeId);
		
		if (agent == null) {
			reporter.assert(false, "No agent named",choiceForAgent.getSelectedItem(),null,null);
			return;
		}

		String propertyName = choiceForProperty.getSelectedItem();
		if (propertyName == null || propertyName == NONE)
			return;
		
		
		agent.removeProperty(propertyName);
		displayAgent(nodeId);
	}

	void buttonChangeProperty_ActionPerformed(java.awt.event.ActionEvent event)
	{
		String nodeId = choiceForAgent.getSelectedItem();
		if (nodeId == null || nodeId == NONE)
			return;
		
		String propertyName = choiceForProperty.getSelectedItem();
		if (propertyName == null || propertyName == NONE)
			return;
		
		Agent agent = exec.getActiveAgent(nodeId);
		if (agent != null) {
			
			Vector values = ValueList.parseValues(textFieldForValue.getText());
			if (values.size() == 0)
				agent.removeProperty(propertyName);
			else if (values.size() == 1)
				agent.setProperty(propertyName, (String)values.elementAt(0));
			else
				agent.setPropertyValues(propertyName, new ValueList(values));
			}
		}

/**
* Tell tool to display state for named agent
*/
	
	public void displayAgent(String agent){
			if (agent == null)
				return;
			if (agent.length() == 0)
				return;
			if (agent == NONE)
				return;
		/**
		* see if agent is on list, refresh list if required
		*/
			if (currentAgent == null || currentAgent.getId() != agent) {
//				choiceForAgent.select(agent);
			}

		/**
		* Get the agents attributes and put them on the list
		*/
			currentAgentProperties = new Vector();
			Vector currentAgentValues = new Vector();
			currentAgent = exec.getActiveAgent(agent);
			reporter.assert(currentAgent != null, "No agent ",agent.toString(),null,null);
			if (currentAgent == null)
				return;
			exec.getItemStateList(agent, currentAgentProperties, currentAgentValues);
		/**
		* Fill property list and select the agents first property
		*/
			choiceForProperty.removeAll();
			choiceForProperty.add(NONE);
			choiceForProperty.select(NONE);
			textFieldForValue.setText("");
			if (currentAgentProperties.size() > 0) {
				for (int i = 0; i<currentAgentProperties.size(); i++) {
					choiceForProperty.add((String) currentAgentProperties.elementAt(i));
				}
			}
			
			updateButtonEnables();
	}
/**
* Update the list of agents
*/
	private final static String NONE = "<none>";
	
	void refreshAgentList(){
		choiceForAgent.removeAll();
		choiceForAgent.add(NONE);
		choiceForAgent.select(NONE);
		for (int mType = 0; mType<=3; mType++) {
			Enumeration enum = exec.getListOfActiveModules(mType);
			while (enum.hasMoreElements()) {
				choiceForAgent.add(((Agent)enum.nextElement()).getId());
			}
		}
	}
/**
* Reset lists to initial state
*/
	void setListsToUnknown() {
		choiceForAgent.removeAll();
		choiceForAgent.add(NONE);
		choiceForAgent.select(NONE);

		choiceForProperty.removeAll();
		choiceForProperty.add(NONE);
		choiceForProperty.select(NONE);

		textFieldForValue.setText("");
	}
/**
* Update button enable states based on the contents of the fields
*/
	void updateButtonEnables() {
		buttonDeleteAgent.setEnabled(NONE != choiceForAgent.getSelectedItem());
		boolean propSelected = NONE != choiceForProperty.getSelectedItem();
		buttonDeleteProperty.setEnabled(propSelected);
		textFieldForValue.setEnabled(propSelected);
		buttonChangeProperty.setEnabled(propSelected);
	}
/**
* Reset to unknownProperties
*/
	void setPropertyToUnknown() {
		choiceForProperty.select(NONE);
		textFieldForValue.setText("");
		buttonDeleteProperty.setEnabled(false);
		textFieldForValue.setEnabled(false);
		buttonChangeProperty.setEnabled(false);
	}
/**
* Watch the exec
*/
	public void setExec(ExecToController exec) {
		this.exec = exec;
		this.reporter = exec.makeReporter("SimpleAdminFrame");
//		exec.addObserver(this);
		refreshAgentList();
	}

	class SymText implements java.awt.event.TextListener
	{
		public void textValueChanged(java.awt.event.TextEvent event)
		{
			Object object = event.getSource();
			if (object == textFieldForValue)
				textFieldForValue_TextValueChanged(event);
		}
	}

	void textFieldForValue_TextValueChanged(java.awt.event.TextEvent event)
	{
		buttonChangeProperty.setEnabled(true);
	}

	void buttonRefresh_ActionPerformed(java.awt.event.ActionEvent event)
	{
		refreshAgentList();
	}
	public void setTitle(String title) {
		super.setTitle("Properties, "+title);
	}
}
