/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.monitor;

import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import org.mitre.pam.util.AuthContext;
import org.mitre.pdif.eventParser.ValueList;

/**
* Serves a  file if the user have valid access. 
* @author Nazario Irizarry, 7 December 1998
*/

public class SrvOneFileValidated extends SrvServeOneFile {

	String realm;
	ValueList accessList;
	
    public SrvOneFileValidated(File fileToGet, String realm, ValueList accessList) {
    	super(fileToGet);
    	this.accessList = accessList;
    	this.realm = realm;
	}

    public String getServletInfo() {
		return "Serve one specific file after validating the user";
	}

/**
* Implement the GET method
*/
	protected void doGet (HttpServletRequest req, HttpServletResponse res)
	throws ServletException, IOException {

	/*
	* Begin access check +++++++++
	*/
		AuthContext context = getAuthContext(req, res);	

		if (!context.verifyAccess(reporter, this, "file "+fileToGet.getName()+" retrieved"))
			return;
	/*
	* End access check ------------
	*/
		
		super.doGet( req, res);
	}
    
}
