/* Copyright 1998 The MITRE Corporation. ALL RIGHTS RESERVED */
package org.mitre.pam.service.resource;

import org.mitre.pam.interfaces.Agent;
import org.mitre.pam.interfaces.Reporter;

public interface AccessibleAgent /* extends Agent */ {
/**
* Get the id, also implemented by the Agent interface
*/
	public String getId();
/**
* Allows access to the agents consumption model.
*/
	public RateConsumer getModel();
/**
* Get the agents reporter, also implemented by the Agent interface
*/
	public Reporter getReporter();
/**
* Interrupt a currently delayed thread and recalculate the delay time
*/
	public void interruptAndRecalculateDelay();
/**
* Is this agent in delay
*/
	public boolean isInDelay();
/**
* Allow the pool to notify its consumers that it has been discarded
*/
	public void poolWasDiscarded();
/**
* Allows pool members to retract bids that may have been
* made to consume files.
*/
	public void retractIfNeeded();
/**
* Allows access to the agents super.setProperty()
*/
	public void superSetProperty(String property, double value) ;
/**
* Allows access to the agents super.setProperty()
*/
	public void superSetProperty(String property, String value) ;
}