/* Copyright 1999 The MITRE Corporation. ALL RIGHTS RESERVED */

package org.mitre.pam.putter.mapdim;

import java.util.Hashtable;

import org.mitre.pam.interfaces.Product;

import com.ofx.repository.SxSpatialObject;
import com.ofx.repository.SxClass;
import com.ofx.geometry.SxGeometryInterface;

/**
* @author Ayal Spitz.
* @author Nazario Irizarry, Jr.
*/
public class PAMSpatialObject extends SxSpatialObject{
	public PAMSpatialObject(String classDef,String identifier){
		super(classDef,identifier);
	}
	
	public PAMSpatialObject(SxClass classDef){
		super(classDef);
	}

	public PAMSpatialObject(SxClass classDef,String identifier,
							SxGeometryInterface geometry){
		super(classDef,identifier,geometry);
	}

	public PAMSpatialObject(SxClass classDef,String identifier){
		super(classDef,identifier);
	}
	
// -------------------------------------------------------------------------
	public final static int	FRIEND_FOE_UNKNOWN = 0;
	public final static int	FRIEND_FOE_FRIEND = 1;
	public final static int	FRIEND_FOE_FOE = 2;

	public static final String		LAYER_AIR			= "pam_Air";
	public static final String		LAYER_GROUND		= "pam_Ground";
	public static final String 		LAYER_SURFACE		= "pam_Surface";
	public static final String		LAYER_SUBSURFACE	= "pam_Subsurface";
	public static final String		LAYER_SPACE 		= "pam_Space";

	public Product			spatialObjProd = null;
	public String			layer = null;
	public double			lat = 0.0;
	public double			lon = 0.0;
	public double			course = 0.0;
	public boolean			hasCourse = false;
	public int				friendFoe = FRIEND_FOE_UNKNOWN;
	
}